diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py ns-3.41/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py
--- ns-3.40/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py	2023-09-27 13:30:37.894839800 -0700
+++ ns-3.41/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py	2024-02-09 14:44:08.561794800 -0800
@@ -1,5 +1,13 @@
 import math
-from ns import ns
+
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 from gi.repository import GooCanvas
 
 try:
@@ -7,6 +15,7 @@
 except ModuleNotFoundError:
     from visualizer.base import Link, transform_distance_canvas_to_simulation
 
+
 ## WifiLink class
 class WifiLink(Link):
     ## @var node1
@@ -31,15 +40,19 @@
         super(WifiLink, self).__init__()
         self.node1 = sta
         self.dev = dev
-        self.node2 = None # ap
+        self.node2 = None  # ap
         self.canvas_item = GooCanvas.CanvasGroup(parent=parent_canvas_item)
-        self.invisible_line = GooCanvas.CanvasPolyline(parent=self.canvas_item,
-                                                 line_width=25.0,
-                                                 visibility=GooCanvas.CanvasItemVisibility.HIDDEN)
-        self.visible_line = GooCanvas.CanvasPolyline(parent=self.canvas_item,
-                                              line_width=1.0,
-                                              stroke_color_rgba=0xC00000FF,
-                                              line_dash=GooCanvas.CanvasLineDash.newv([2.0, 2.0 ]))
+        self.invisible_line = GooCanvas.CanvasPolyline(
+            parent=self.canvas_item,
+            line_width=25.0,
+            visibility=GooCanvas.CanvasItemVisibility.HIDDEN,
+        )
+        self.visible_line = GooCanvas.CanvasPolyline(
+            parent=self.canvas_item,
+            line_width=1.0,
+            stroke_color_rgba=0xC00000FF,
+            line_dash=GooCanvas.CanvasLineDash.newv([2.0, 2.0]),
+        )
         # self.invisible_line.set_property("pointer-events", (GooCanvas.CanvasPointerEvents.STROKE_MASK
         #                                             |GooCanvas.CanvasPointerEvents.FILL_MASK
         #                                             |GooCanvas.CanvasPointerEvents.PAINTED_MASK))
@@ -99,13 +112,17 @@
         pos2_x, pos2_y = self.node2.get_position()
         dx = pos2_x - pos1_x
         dy = pos2_y - pos1_y
-        d = transform_distance_canvas_to_simulation(math.sqrt(dx*dx + dy*dy))
+        d = transform_distance_canvas_to_simulation(math.sqrt(dx * dx + dy * dy))
         mac = self.dev.GetMac()
-        tooltip.set_text(("WiFi link between STA Node %i and AP Node %i; distance=%.2f m.\n"
-                          "SSID: %s\n"
-                          "BSSID: %s")
-                         % (self.node1.node_index, self.node2.node_index, d,
-                            mac.GetSsid(), mac.GetBssid()))
+        tooltip.set_text(
+            (
+                "WiFi link between STA Node %i and AP Node %i; distance=%.2f m.\n"
+                "SSID: %s\n"
+                "BSSID: %s"
+            )
+            % (self.node1.node_index, self.node2.node_index, d, mac.GetSsid(), mac.GetBssid())
+        )
+
 
 ## WifiLinkMonitor class
 class WifiLinkMonitor(object):
@@ -118,8 +135,8 @@
         @param self The object pointer.
         @param dummy_viz A dummy visualizer
         """
-        self.access_points = {} # bssid -> node
-        self.stations = [] # list of (sta_netdevice, viz_node, wifi_link)
+        self.access_points = {}  # bssid -> node
+        self.stations = []  # list of (sta_netdevice, viz_node, wifi_link)
 
     def scan_nodes(self, viz):
         """! Scan nodes function.
@@ -127,7 +144,7 @@
         @param viz The visualizer object
         @return none
         """
-        for (sta_netdevice, viz_node, wifi_link) in self.stations:
+        for sta_netdevice, viz_node, wifi_link in self.stations:
             wifi_link.destroy()
 
         self.access_points = {}
@@ -146,8 +163,8 @@
                 elif isinstance(wifi_mac, ns.wifi.ApWifiMac):
                     bssid = ns.network.Mac48Address.ConvertFrom(dev.GetAddress())
                     self.access_points[str(bssid)] = node
-        #print "APs: ", self.access_points
-        #print "STAs: ", self.stations
+        # print "APs: ", self.access_points
+        # print "STAs: ", self.stations
 
     def simulation_periodic_update(self, viz):
         """! Simulation Periodic Update function.
@@ -155,12 +172,12 @@
         @param viz The visualizer object
         @return none
         """
-        for (sta_netdevice, viz_node, wifi_link) in self.stations:
+        for sta_netdevice, viz_node, wifi_link in self.stations:
             if not sta_netdevice.IsLinkUp():
                 wifi_link.set_ap(None)
                 continue
             bssid = str(sta_netdevice.GetMac().GetBssid())
-            if bssid == '00:00:00:00:00:00':
+            if bssid == "00:00:00:00:00:00":
                 wifi_link.set_ap(None)
                 continue
             ap = self.access_points[bssid]
@@ -172,7 +189,7 @@
         @param viz The visualizer object
         @return none
         """
-        for (dummy_sta_netdevice, dummy_viz_node, wifi_link) in self.stations:
+        for dummy_sta_netdevice, dummy_viz_node, wifi_link in self.stations:
             if wifi_link is not None:
                 wifi_link.update_points()
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/visualizer/visualizer/svgitem.py ns-3.41/src/visualizer/visualizer/svgitem.py
--- ns-3.40/src/visualizer/visualizer/svgitem.py	2023-09-27 13:30:37.894839800 -0700
+++ ns-3.41/src/visualizer/visualizer/svgitem.py	2024-02-09 14:44:08.561794800 -0800
@@ -1,8 +1,9 @@
-from gi.repository import GObject, GooCanvas
-import rsvg
-#import cairo
+# import cairo
 import os.path
 
+import rsvg
+from gi.repository import GObject, GooCanvas
+
 
 ## SvgItem class
 class SvgItem(GooCanvas.ItemSimple):
@@ -35,38 +36,43 @@
 
     ## setup our custom properties
     __gproperties__ = {
-        'x': (float,                                # property type
-              'X',                                  # property nick name
-              'The x coordinate of a SVG image',    # property description
-              -10e6,                                # property minimum value
-              10e6,                                 # property maximum value
-              0,                                    # property default value
-              GObject.PARAM_READWRITE),             # property flags
-
-        'y': (float,
-              'Y',
-              'The y coordinate of a SVG image',
-              -10e6,
-              10e6,
-              0,
-              GObject.PARAM_READWRITE),
-
-        'width': (float,
-                  'Width',
-                  'The width of the SVG Image',
-                  0,
-                  10e6,
-                  0,
-                  GObject.PARAM_READWRITE),
-
-        'height': (float,
-                   'Height',
-                   'The width of the SVG Image',
-                   0,
-                   10e6,
-                   0,
-                   GObject.PARAM_READWRITE),
-        }
+        "x": (
+            float,  # property type
+            "X",  # property nick name
+            "The x coordinate of a SVG image",  # property description
+            -10e6,  # property minimum value
+            10e6,  # property maximum value
+            0,  # property default value
+            GObject.PARAM_READWRITE,
+        ),  # property flags
+        "y": (
+            float,
+            "Y",
+            "The y coordinate of a SVG image",
+            -10e6,
+            10e6,
+            0,
+            GObject.PARAM_READWRITE,
+        ),
+        "width": (
+            float,
+            "Width",
+            "The width of the SVG Image",
+            0,
+            10e6,
+            0,
+            GObject.PARAM_READWRITE,
+        ),
+        "height": (
+            float,
+            "Height",
+            "The width of the SVG Image",
+            0,
+            10e6,
+            0,
+            GObject.PARAM_READWRITE,
+        ),
+    }
 
     def __init__(self, x, y, rsvg_handle, **kwargs):
         """!
@@ -97,26 +103,26 @@
         @param value property value
         @return exception if unknown property
         """
-        if pspec.name == 'x':
+        if pspec.name == "x":
             self.x = value
 
             # make sure we update the display
             self.changed(True)
 
-        elif pspec.name == 'y':
+        elif pspec.name == "y":
             self.y = value
 
             # make sure we update the display
             self.changed(True)
 
-        elif pspec.name == 'width':
+        elif pspec.name == "width":
             self.custom_width = value
             self._size_changed()
 
             # make sure we update the display
             self.changed(True)
 
-        elif pspec.name == 'height':
+        elif pspec.name == "height":
             self.custom_height = value
             self._size_changed()
 
@@ -124,7 +130,7 @@
             self.changed(True)
 
         else:
-            raise AttributeError('unknown property %s' % pspec.name)
+            raise AttributeError("unknown property %s" % pspec.name)
 
     def _size_changed(self):
         """!
@@ -141,12 +147,12 @@
             self.width = self.custom_width
             self.sx = self.custom_width / self.handle.props.width
             self.sy = self.sx
-            self.height = self.handle.props.height*self.sy
+            self.height = self.handle.props.height * self.sy
         elif self.custom_width is None and self.custom_height is not None:
             self.height = self.custom_height
             self.sy = self.custom_height / self.handle.props.height
-            self.sx  = self.sy
-            self.width = self.handle.props.width*self.sx
+            self.sx = self.sy
+            self.width = self.handle.props.width * self.sx
         else:
             self.width = self.custom_width
             self.height = self.custom_height
@@ -160,23 +166,23 @@
         @param pspec property name
         @return property value or exception if unknown property
         """
-        if pspec.name == 'x':
+        if pspec.name == "x":
             return self.x
 
-        elif pspec.name == 'y':
+        elif pspec.name == "y":
             return self.y
 
-        elif pspec.name == 'width':
+        elif pspec.name == "width":
             self.width = self.handle.props.width
             self.height = self.handle.props.height
 
             return self.width
 
-        elif pspec.name == 'height':
+        elif pspec.name == "height":
             return self.height
 
         else:
-            raise AttributeError('unknown property %s' % pspec.name)
+            raise AttributeError("unknown property %s" % pspec.name)
 
     def do_simple_paint(self, cr, bounds):
         """!
@@ -212,7 +218,9 @@
         @param is_pointer_event is the event a pointer event
         @return true if at or false if not
         """
-        if ((x < self.x) or (x > self.x + self.width)) or ((y < self.y) or (y > self.y + self.height)):
+        if ((x < self.x) or (x > self.x + self.width)) or (
+            (y < self.y) or (y > self.y + self.height)
+        ):
             return False
         else:
             return True
@@ -220,12 +228,12 @@
 
 _rsvg_cache = dict()
 
+
 def rsvg_handle_factory(base_file_name):
     try:
         return _rsvg_cache[base_file_name]
     except KeyError:
-        full_path = os.path.join(os.path.dirname(__file__), 'resource', base_file_name)
+        full_path = os.path.join(os.path.dirname(__file__), "resource", base_file_name)
         rsvg_handle = rsvg.Handle(full_path)
         _rsvg_cache[base_file_name] = rsvg_handle
         return rsvg_handle
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/CMakeLists.txt ns-3.41/src/wifi/CMakeLists.txt
--- ns-3.40/src/wifi/CMakeLists.txt	2023-09-27 13:30:37.894839800 -0700
+++ ns-3.41/src/wifi/CMakeLists.txt	2024-02-09 14:44:08.561794800 -0800
@@ -12,6 +12,7 @@
     helper/wifi-mac-helper.cc
     helper/wifi-radio-energy-model-helper.cc
     helper/yans-wifi-helper.cc
+    model/addba-extension.cc
     model/adhoc-wifi-mac.cc
     model/ampdu-subframe-header.cc
     model/ampdu-tag.cc
@@ -62,6 +63,7 @@
     model/interference-helper.cc
     model/mac-rx-middle.cc
     model/mac-tx-middle.cc
+    model/mgt-action-headers.cc
     model/mgt-headers.cc
     model/mpdu-aggregator.cc
     model/msdu-aggregator.cc
@@ -163,6 +165,7 @@
     helper/wifi-mac-helper.h
     helper/wifi-radio-energy-model-helper.h
     helper/yans-wifi-helper.h
+    model/addba-extension.h
     model/adhoc-wifi-mac.h
     model/ampdu-subframe-header.h
     model/ampdu-tag.h
@@ -213,6 +216,7 @@
     model/interference-helper.h
     model/mac-rx-middle.h
     model/mac-tx-middle.h
+    model/mgt-action-headers.h
     model/mgt-headers.h
     model/mpdu-aggregator.h
     model/msdu-aggregator.h
@@ -320,12 +324,8 @@
   SOURCE_FILES ${source_files}
   HEADER_FILES ${header_files}
   LIBRARIES_TO_LINK
-    ${libnetwork}
-    ${libpropagation}
     ${libenergy}
     ${libspectrum}
-    ${libantenna}
-    ${libmobility}
     ${gsl_libraries}
   TEST_SOURCES
     test/block-ack-test-suite.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/doc/Makefile ns-3.41/src/wifi/doc/Makefile
--- ns-3.40/src/wifi/doc/Makefile	2023-09-27 13:30:37.894839800 -0700
+++ ns-3.41/src/wifi/doc/Makefile	2024-02-09 14:44:08.561794800 -0800
@@ -25,6 +25,8 @@
 	$(FIGURES)/FemHierarchy.eps \
         $(FIGURES)/assoc-manager.eps \
         $(FIGURES)/clear-channel.eps \
+        $(FIGURES)/emlsr-dl-txop.eps \
+        $(FIGURES)/emlsr-ul-txop.eps \
         $(FIGURES)/nist-frame-success-rate.eps \
         $(FIGURES)/nist-frame-success-rate-n.eps \
         $(FIGURES)/nist-frame-success-rate-ac.eps \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/doc/source/conf.py ns-3.41/src/wifi/doc/source/conf.py
--- ns-3.40/src/wifi/doc/source/conf.py	2023-09-27 13:30:37.894839800 -0700
+++ ns-3.41/src/wifi/doc/source/conf.py	2024-02-09 14:44:08.565794700 -0800
@@ -11,202 +11,208 @@
 # All configuration values have a default; values that are commented out
 # serve to show the default.
 
-import sys, os
+import os
+import sys
 
 # If extensions (or modules to document with autodoc) are in another directory,
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
-#sys.path.insert(0, os.path.abspath('.'))
+# sys.path.insert(0, os.path.abspath('.'))
 
 # -- General configuration -----------------------------------------------------
 
 # If your documentation needs a minimal Sphinx version, state it here.
-#needs_sphinx = '1.0'
+# needs_sphinx = '1.0'
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.imgmath']
+extensions = ["sphinx.ext.imgmath"]
 
 # Add any paths that contain templates here, relative to this directory.
-templates_path = ['_templates']
+templates_path = ["_templates"]
 
 # The suffix of source filenames.
-source_suffix = '.rst'
+source_suffix = ".rst"
 
 # The encoding of source files.
-#source_encoding = 'utf-8-sig'
+# source_encoding = 'utf-8-sig'
 
 # The master toctree document.
-master_doc = 'wifi'
+master_doc = "wifi"
 
 # General information about the project.
-project = u'ns-3'
-copyright = u'ns-3 project'
+project = "ns-3"
+copyright = "ns-3 project"
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the
 # built documents.
 #
 # The short X.Y version.
-version = 'ns-3-dev'
+version = "ns-3-dev"
 # The full version, including alpha/beta/rc tags.
-release = 'ns-3-dev'
+release = "ns-3-dev"
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
-#language = None
+# language = None
 
 # There are two options for replacing |today|: either, you set today to some
 # non-false value, then it is used:
-#today = ''
+# today = ''
 # Else, today_fmt is used as the format for a strftime call.
-#today_fmt = '%B %d, %Y'
+# today_fmt = '%B %d, %Y'
 
 # List of patterns, relative to source directory, that match files and
 # directories to ignore when looking for source files.
 exclude_patterns = []
 
 # The reST default role (used for this markup: `text`) to use for all documents.
-#default_role = None
+# default_role = None
 
 # If true, '()' will be appended to :func: etc. cross-reference text.
-#add_function_parentheses = True
+# add_function_parentheses = True
 
 # If true, the current module name will be prepended to all description
 # unit titles (such as .. function::).
-#add_module_names = True
+# add_module_names = True
 
 # If true, sectionauthor and moduleauthor directives will be shown in the
 # output. They are ignored by default.
-#show_authors = False
+# show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = "sphinx"
 
 # A list of ignored prefixes for module index sorting.
-#modindex_common_prefix = []
+# modindex_common_prefix = []
 
 
 # -- Options for HTML output ---------------------------------------------------
 
 # The theme to use for HTML and HTML Help pages.  See the documentation for
 # a list of builtin themes.
-html_theme = 'default'
+html_theme = "default"
 
 # Theme options are theme-specific and customize the look and feel of a theme
 # further.  For a list of options available for each theme, see the
 # documentation.
-#html_theme_options = {}
+# html_theme_options = {}
 
 # Add any paths that contain custom themes here, relative to this directory.
-#html_theme_path = []
+# html_theme_path = []
 
 # The name for this set of Sphinx documents.  If None, it defaults to
 # "<project> v<release> documentation".
-#html_title = None
+# html_title = None
 
 # A shorter title for the navigation bar.  Default is the same as html_title.
-#html_short_title = None
+# html_short_title = None
 
 # The name of an image file (relative to this directory) to place at the top
 # of the sidebar.
-#html_logo = None
+# html_logo = None
 
 # The name of an image file (within the static path) to use as favicon of the
 # docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
 # pixels large.
-#html_favicon = None
+# html_favicon = None
 
 # Add any paths that contain custom static files (such as style sheets) here,
 # relative to this directory. They are copied after the builtin static files,
 # so a file named "default.css" will overwrite the builtin "default.css".
-#html_static_path = ['_static']
+# html_static_path = ['_static']
 
 # If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
 # using the given strftime format.
-#html_last_updated_fmt = '%b %d, %Y'
+# html_last_updated_fmt = '%b %d, %Y'
 
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
-#html_use_smartypants = True
+# html_use_smartypants = True
 
 # Custom sidebar templates, maps document names to template names.
-#html_sidebars = {}
+# html_sidebars = {}
 
 # Additional templates that should be rendered to pages, maps page names to
 # template names.
-#html_additional_pages = {}
+# html_additional_pages = {}
 
 # If false, no module index is generated.
-#html_domain_indices = True
+# html_domain_indices = True
 
 # If false, no index is generated.
-#html_use_index = True
+# html_use_index = True
 
 # If true, the index is split into individual pages for each letter.
-#html_split_index = False
+# html_split_index = False
 
 # If true, links to the reST sources are added to the pages.
-#html_show_sourcelink = True
+# html_show_sourcelink = True
 
 # If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
-#html_show_sphinx = True
+# html_show_sphinx = True
 
 # If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
-#html_show_copyright = True
+# html_show_copyright = True
 
 # If true, an OpenSearch description file will be output, and all pages will
 # contain a <link> tag referring to it.  The value of this option must be the
 # base URL from which the finished HTML is served.
-#html_use_opensearch = ''
+# html_use_opensearch = ''
 
 # This is the file name suffix for HTML files (e.g. ".xhtml").
-#html_file_suffix = None
+# html_file_suffix = None
 
 # Output file base name for HTML help builder.
-#htmlhelp_basename = 'ns-3doc'
+# htmlhelp_basename = 'ns-3doc'
 
 
 # -- Options for LaTeX output --------------------------------------------------
 
 # The paper size ('letter' or 'a4').
-#latex_paper_size = 'letter'
+# latex_paper_size = 'letter'
 
 # The font size ('10pt', '11pt' or '12pt').
-#latex_font_size = '10pt'
+# latex_font_size = '10pt'
 
 # Grouping the document tree into LaTeX files. List of tuples
 # (source start file, target name, title, author, documentclass [howto/manual]).
 latex_documents = [
-#  ('wifi-testing', 'wifi-doc-testing.tex', u'Wi-Fi Testing Documentation', u'ns-3 project', 'manual'),
-#  ('wifi-design', 'wifi-doc-design.tex', u'Wi-Fi Design Documentation', u'ns-3 project', 'manual'),
-#  ('wifi-user', 'wifi-doc-user.tex', u'Wi-Fi User Documentation', u'ns-3 project', 'manual'),
-  ('wifi', 'wifi-module-doc.tex', u'The ns-3 Wi-Fi Module Documentation', u'ns-3 project', 'manual'),
+    #  ('wifi-testing', 'wifi-doc-testing.tex', u'Wi-Fi Testing Documentation', u'ns-3 project', 'manual'),
+    #  ('wifi-design', 'wifi-doc-design.tex', u'Wi-Fi Design Documentation', u'ns-3 project', 'manual'),
+    #  ('wifi-user', 'wifi-doc-user.tex', u'Wi-Fi User Documentation', u'ns-3 project', 'manual'),
+    (
+        "wifi",
+        "wifi-module-doc.tex",
+        "The ns-3 Wi-Fi Module Documentation",
+        "ns-3 project",
+        "manual",
+    ),
 ]
 
 # The name of an image file (relative to this directory) to place at the top of
 # the title page.
-#latex_logo = None
+# latex_logo = None
 
 # For "manual" documents, if this is true, then toplevel headings are parts,
 # not chapters.
-#latex_use_parts = False
+# latex_use_parts = False
 
 # If true, show page references after internal links.
-#latex_show_pagerefs = False
+# latex_show_pagerefs = False
 
 # If true, show URL addresses after external links.
-#latex_show_urls = False
+# latex_show_urls = False
 
 # Additional stuff for the LaTeX preamble.
-#latex_preamble = ''
+# latex_preamble = ''
 
 # Documents to append as an appendix to all manuals.
-#latex_appendices = []
+# latex_appendices = []
 
 # If false, no module index is generated.
-#latex_domain_indices = True
-
+# latex_domain_indices = True
 
 
 # add page breaks in the pdf. Level 1 is for top-level sections, level 2 for subsections, and so on.
@@ -217,7 +223,4 @@
 
 # One entry per manual page. List of tuples
 # (source start file, name, description, authors, manual section).
-man_pages = [
-    ('index', 'ns-3-model-library', u'ns-3 Model Library',
-     [u'ns-3 project'], 1)
-]
+man_pages = [("index", "ns-3-model-library", "ns-3 Model Library", ["ns-3 project"], 1)]
